summaryrefslogtreecommitdiff
path: root/src/share/common
blob: 4aa3f7ce14857b60390a2c2da02bf1cabddaeee7 (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" = 'true' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep -q -F "$string" "$file" 2>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v -F "$string" "$file" >"$tempfile"
  301. cat "$tempfile" > "$file"
  302. rm "$tempfile"
  303. return 0
  304. # otherwise return 1
  305. else
  306. return 1
  307. fi
  308. }
  309. # remove all lines with MonkeySphere strings in file
  310. remove_monkeysphere_lines() {
  311. local file
  312. local tempfile
  313. file="$1"
  314. # return error if file does not exist
  315. if [ ! -e "$file" ] ; then
  316. return 1
  317. fi
  318. # just return ok if the file is empty, since there aren't any
  319. # lines to remove
  320. if [ ! -s "$file" ] ; then
  321. return 0
  322. fi
  323. tempfile=$(mktemp "${file}.XXXXXXX") || \
  324. failure "Could not make temporary file '${file}.XXXXXXX'."
  325. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  326. "$file" >"$tempfile"
  327. cat "$tempfile" > "$file"
  328. rm "$tempfile"
  329. }
  330. # translate ssh-style path variables %h and %u
  331. translate_ssh_variables() {
  332. local uname
  333. local home
  334. uname="$1"
  335. path="$2"
  336. # get the user's home directory
  337. userHome=$(get_homedir "$uname")
  338. # translate '%u' to user name
  339. path=${path/\%u/"$uname"}
  340. # translate '%h' to user home directory
  341. path=${path/\%h/"$userHome"}
  342. echo "$path"
  343. }
  344. # test that a string to conforms to GPG's expiration format
  345. test_gpg_expire() {
  346. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  347. }
  348. # check that a file is properly owned, and that all it's parent
  349. # directories are not group/other writable
  350. check_key_file_permissions() {
  351. local uname
  352. local path
  353. uname="$1"
  354. path="$2"
  355. if [ "$STRICT_MODES" = 'false' ] ; then
  356. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  357. return 0
  358. fi
  359. log debug "checking path permission '$path'..."
  360. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  361. }
  362. # return a list of all users on the system
  363. list_users() {
  364. if type getent &>/dev/null ; then
  365. # for linux and FreeBSD systems
  366. getent passwd | cut -d: -f1
  367. elif type dscl &>/dev/null ; then
  368. # for Darwin systems
  369. dscl localhost -list /Search/Users
  370. else
  371. failure "Neither getent or dscl is in the path! Could not determine list of users."
  372. fi
  373. }
  374. # return the path to the home directory of a user
  375. get_homedir() {
  376. local uname=${1:-`whoami`}
  377. eval "echo ~${uname}"
  378. }
  379. # return the primary group of a user
  380. get_primary_group() {
  381. local uname=${1:-`whoami`}
  382. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  383. }
  384. ### CONVERSION UTILITIES
  385. # output the ssh key for a given key ID
  386. gpg2ssh() {
  387. local keyID
  388. keyID="$1"
  389. gpg --export "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  390. }
  391. # output known_hosts line from ssh key
  392. ssh2known_hosts() {
  393. local host
  394. local port
  395. local key
  396. # FIXME this does not properly deal with IPv6 hosts using the
  397. # standard port (because it's unclear whether their final
  398. # colon-delimited address section is a port number or an address
  399. # string)
  400. host=${1%:*}
  401. port=${1##*:}
  402. key="$2"
  403. # specify the host and port properly for new ssh known_hosts
  404. # format
  405. if [ "$port" != "$host" ] ; then
  406. host="[${host}]:${port}"
  407. fi
  408. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  409. }
  410. # output authorized_keys line from ssh key
  411. ssh2authorized_keys() {
  412. local userID
  413. local key
  414. userID="$1"
  415. key="$2"
  416. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  417. }
  418. # convert key from gpg to ssh known_hosts format
  419. gpg2known_hosts() {
  420. local host
  421. local keyID
  422. local key
  423. host="$1"
  424. keyID="$2"
  425. key=$(gpg2ssh "$keyID")
  426. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  427. # all lines in the known_hosts file. why?
  428. # NOTE: just in case, the COMMENT can be matched with the
  429. # following regexp:
  430. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  431. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  432. }
  433. # convert key from gpg to ssh authorized_keys format
  434. gpg2authorized_keys() {
  435. local userID
  436. local keyID
  437. local key
  438. userID="$1"
  439. keyID="$2"
  440. key=$(gpg2ssh "$keyID")
  441. # NOTE: just in case, the COMMENT can be matched with the
  442. # following regexp:
  443. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  444. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  445. }
  446. ### GPG UTILITIES
  447. # retrieve all keys with given user id from keyserver
  448. # FIXME: need to figure out how to retrieve all matching keys
  449. # (not just first N (5 in this case))
  450. gpg_fetch_userid() {
  451. local returnCode=0
  452. local userID
  453. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  454. return 0
  455. fi
  456. userID="$1"
  457. log verbose " checking keyserver $KEYSERVER... "
  458. echo 1,2,3,4,5 | \
  459. gpg --quiet --batch --with-colons \
  460. --command-fd 0 --keyserver "$KEYSERVER" \
  461. --search ="$userID" &>/dev/null
  462. returnCode="$?"
  463. return "$returnCode"
  464. }
  465. ########################################################################
  466. ### PROCESSING FUNCTIONS
  467. # userid and key policy checking
  468. # the following checks policy on the returned keys
  469. # - checks that full key has appropriate valididy (u|f)
  470. # - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
  471. # - checks that requested user ID has appropriate validity
  472. # (see /usr/share/doc/gnupg/DETAILS.gz)
  473. # output is one line for every found key, in the following format:
  474. #
  475. # flag:sshKey
  476. #
  477. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  478. # "sshKey" is the translated gpg key
  479. #
  480. # all log output must go to stderr, as stdout is used to pass the
  481. # flag:sshKey to the calling function.
  482. #
  483. # expects global variable: "MODE"
  484. process_user_id() {
  485. local returnCode=0
  486. local userID
  487. local requiredCapability
  488. local requiredPubCapability
  489. local gpgOut
  490. local type
  491. local validity
  492. local keyid
  493. local uidfpr
  494. local usage
  495. local keyOK
  496. local uidOK
  497. local lastKey
  498. local lastKeyOK
  499. local fingerprint
  500. userID="$1"
  501. # set the required key capability based on the mode
  502. if [ "$MODE" = 'known_hosts' ] ; then
  503. requiredCapability="$REQUIRED_HOST_KEY_CAPABILITY"
  504. elif [ "$MODE" = 'authorized_keys' ] ; then
  505. requiredCapability="$REQUIRED_USER_KEY_CAPABILITY"
  506. fi
  507. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  508. # fetch the user ID if necessary/requested
  509. gpg_fetch_userid "$userID"
  510. # output gpg info for (exact) userid and store
  511. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  512. --with-fingerprint --with-fingerprint \
  513. ="$userID" 2>/dev/null) || returnCode="$?"
  514. # if the gpg query return code is not 0, return 1
  515. if [ "$returnCode" -ne 0 ] ; then
  516. log verbose " no primary keys found."
  517. return 1
  518. fi
  519. # loop over all lines in the gpg output and process.
  520. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  521. while IFS=: read -r type validity keyid uidfpr usage ; do
  522. # process based on record type
  523. case $type in
  524. 'pub') # primary keys
  525. # new key, wipe the slate
  526. keyOK=
  527. uidOK=
  528. lastKey=pub
  529. lastKeyOK=
  530. fingerprint=
  531. log verbose " primary key found: $keyid"
  532. # if overall key is not valid, skip
  533. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  534. log debug " - unacceptable primary key validity ($validity)."
  535. continue
  536. fi
  537. # if overall key is disabled, skip
  538. if check_capability "$usage" 'D' ; then
  539. log debug " - key disabled."
  540. continue
  541. fi
  542. # if overall key capability is not ok, skip
  543. if ! check_capability "$usage" $requiredPubCapability ; then
  544. log debug " - unacceptable primary key capability ($usage)."
  545. continue
  546. fi
  547. # mark overall key as ok
  548. keyOK=true
  549. # mark primary key as ok if capability is ok
  550. if check_capability "$usage" $requiredCapability ; then
  551. lastKeyOK=true
  552. fi
  553. ;;
  554. 'uid') # user ids
  555. if [ "$lastKey" != pub ] ; then
  556. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  557. continue
  558. fi
  559. # if an acceptable user ID was already found, skip
  560. if [ "$uidOK" = 'true' ] ; then
  561. continue
  562. fi
  563. # if the user ID does matches...
  564. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  565. # and the user ID validity is ok
  566. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  567. # mark user ID acceptable
  568. uidOK=true
  569. else
  570. log debug " - unacceptable user ID validity ($validity)."
  571. fi
  572. else
  573. continue
  574. fi
  575. # output a line for the primary key
  576. # 0 = ok, 1 = bad
  577. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  578. log verbose " * acceptable primary key."
  579. if [ -z "$sshKey" ] ; then
  580. log error " ! primary key could not be translated (not RSA?)."
  581. else
  582. echo "0:${sshKey}"
  583. fi
  584. else
  585. log debug " - unacceptable primary key."
  586. if [ -z "$sshKey" ] ; then
  587. log debug " ! primary key could not be translated (not RSA?)."
  588. else
  589. echo "1:${sshKey}"
  590. fi
  591. fi
  592. ;;
  593. 'sub') # sub keys
  594. # unset acceptability of last key
  595. lastKey=sub
  596. lastKeyOK=
  597. fingerprint=
  598. # don't bother with sub keys if the primary key is not valid
  599. if [ "$keyOK" != true ] ; then
  600. continue
  601. fi
  602. # don't bother with sub keys if no user ID is acceptable:
  603. if [ "$uidOK" != true ] ; then
  604. continue
  605. fi
  606. # if sub key validity is not ok, skip
  607. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  608. log debug " - unacceptable sub key validity ($validity)."
  609. continue
  610. fi
  611. # if sub key capability is not ok, skip
  612. if ! check_capability "$usage" $requiredCapability ; then
  613. log debug " - unacceptable sub key capability ($usage)."
  614. continue
  615. fi
  616. # mark sub key as ok
  617. lastKeyOK=true
  618. ;;
  619. 'fpr') # key fingerprint
  620. fingerprint="$uidfpr"
  621. sshKey=$(gpg2ssh "$fingerprint")
  622. # if the last key was the pub key, skip
  623. if [ "$lastKey" = pub ] ; then
  624. continue
  625. fi
  626. # output a line for the sub key
  627. # 0 = ok, 1 = bad
  628. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  629. log verbose " * acceptable sub key."
  630. if [ -z "$sshKey" ] ; then
  631. log error " ! sub key could not be translated (not RSA?)."
  632. else
  633. echo "0:${sshKey}"
  634. fi
  635. else
  636. log debug " - unacceptable sub key."
  637. if [ -z "$sshKey" ] ; then
  638. log debug " ! sub key could not be translated (not RSA?)."
  639. else
  640. echo "1:${sshKey}"
  641. fi
  642. fi
  643. ;;
  644. esac
  645. done | sort -t: -k1 -n -r
  646. # NOTE: this last sort is important so that the "good" keys (key
  647. # flag '0') come last. This is so that they take precedence when
  648. # being processed in the key files over "bad" keys (key flag '1')
  649. }
  650. # process a single host in the known_host file
  651. process_host_known_hosts() {
  652. local host
  653. local userID
  654. local noKey=
  655. local nKeys
  656. local nKeysOK
  657. local ok
  658. local sshKey
  659. local tmpfile
  660. # set the key processing mode
  661. export MODE='known_hosts'
  662. host="$1"
  663. userID="ssh://${host}"
  664. log verbose "processing: $host"
  665. nKeys=0
  666. nKeysOK=0
  667. IFS=$'\n'
  668. for line in $(process_user_id "${userID}") ; do
  669. # note that key was found
  670. nKeys=$((nKeys+1))
  671. ok=$(echo "$line" | cut -d: -f1)
  672. sshKey=$(echo "$line" | cut -d: -f2)
  673. if [ -z "$sshKey" ] ; then
  674. continue
  675. fi
  676. # remove any old host key line, and note if removed nothing is
  677. # removed
  678. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  679. # if key OK, add new host line
  680. if [ "$ok" -eq '0' ] ; then
  681. # note that key was found ok
  682. nKeysOK=$((nKeysOK+1))
  683. # hash if specified
  684. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  685. # FIXME: this is really hackish cause ssh-keygen won't
  686. # hash from stdin to stdout
  687. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  688. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  689. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  690. cat "$tmpfile" >> "$KNOWN_HOSTS"
  691. rm -f "$tmpfile" "${tmpfile}.old"
  692. else
  693. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  694. fi
  695. # log if this is a new key to the known_hosts file
  696. if [ "$noKey" ] ; then
  697. log info "* new key for $host added to known_hosts file."
  698. fi
  699. fi
  700. done
  701. # if at least one key was found...
  702. if [ "$nKeys" -gt 0 ] ; then
  703. # if ok keys were found, return 0
  704. if [ "$nKeysOK" -gt 0 ] ; then
  705. return 0
  706. # else return 2
  707. else
  708. return 2
  709. fi
  710. # if no keys were found, return 1
  711. else
  712. return 1
  713. fi
  714. }
  715. # update the known_hosts file for a set of hosts listed on command
  716. # line
  717. update_known_hosts() {
  718. local returnCode=0
  719. local nHosts
  720. local nHostsOK
  721. local nHostsBAD
  722. local fileCheck
  723. local host
  724. local newUmask
  725. # the number of hosts specified on command line
  726. nHosts="$#"
  727. nHostsOK=0
  728. nHostsBAD=0
  729. # touch the known_hosts file so that the file permission check
  730. # below won't fail upon not finding the file
  731. if [ ! -f "$KNOWN_HOSTS" ]; then
  732. # make sure to create any files or directories with the appropriate write bits turned off:
  733. newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
  734. [ -d $(dirname "$KNOWN_HOSTS") ] \
  735. || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$KNOWN_HOSTS") ) \
  736. || failure "Could not create path to known_hosts file '$KNOWN_HOSTS'"
  737. # make sure to create this file with the appropriate bits turned off:
  738. (umask "$newUmask" && touch "$KNOWN_HOSTS") \
  739. || failure "Unable to create known_hosts file '$KNOWN_HOSTS'"
  740. fi
  741. # check permissions on the known_hosts file path
  742. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" \
  743. || failure "Bad permissions governing known_hosts file '$KNOWN_HOSTS'"
  744. # create a lockfile on known_hosts:
  745. lock create "$KNOWN_HOSTS"
  746. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  747. trap "lock remove $KNOWN_HOSTS" EXIT
  748. # note pre update file checksum
  749. fileCheck=$(file_hash "$KNOWN_HOSTS")
  750. for host ; do
  751. # process the host
  752. process_host_known_hosts "$host" || returnCode="$?"
  753. # note the result
  754. case "$returnCode" in
  755. 0)
  756. nHostsOK=$((nHostsOK+1))
  757. ;;
  758. 2)
  759. nHostsBAD=$((nHostsBAD+1))
  760. ;;
  761. esac
  762. # touch the lockfile, for good measure.
  763. lock touch "$KNOWN_HOSTS"
  764. done
  765. # remove the lockfile and the trap
  766. lock remove "$KNOWN_HOSTS"
  767. trap - EXIT
  768. # note if the known_hosts file was updated
  769. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  770. log debug "known_hosts file updated."
  771. fi
  772. # if an acceptable host was found, return 0
  773. if [ "$nHostsOK" -gt 0 ] ; then
  774. return 0
  775. # else if no ok hosts were found...
  776. else
  777. # if no bad host were found then no hosts were found at all,
  778. # and return 1
  779. if [ "$nHostsBAD" -eq 0 ] ; then
  780. return 1
  781. # else if at least one bad host was found, return 2
  782. else
  783. return 2
  784. fi
  785. fi
  786. }
  787. # process hosts from a known_hosts file
  788. process_known_hosts() {
  789. local hosts
  790. # exit if the known_hosts file does not exist
  791. if [ ! -e "$KNOWN_HOSTS" ] ; then
  792. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  793. fi
  794. log debug "processing known_hosts file:"
  795. log debug " $KNOWN_HOSTS"
  796. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  797. if [ -z "$hosts" ] ; then
  798. log debug "no hosts to process."
  799. return
  800. fi
  801. # take all the hosts from the known_hosts file (first
  802. # field), grep out all the hashed hosts (lines starting
  803. # with '|')...
  804. update_known_hosts $hosts
  805. }
  806. # process uids for the authorized_keys file
  807. process_uid_authorized_keys() {
  808. local userID
  809. local nKeys
  810. local nKeysOK
  811. local ok
  812. local sshKey
  813. # set the key processing mode
  814. export MODE='authorized_keys'
  815. userID="$1"
  816. log verbose "processing: $userID"
  817. nKeys=0
  818. nKeysOK=0
  819. IFS=$'\n'
  820. for line in $(process_user_id "$userID") ; do
  821. # note that key was found
  822. nKeys=$((nKeys+1))
  823. ok=$(echo "$line" | cut -d: -f1)
  824. sshKey=$(echo "$line" | cut -d: -f2)
  825. if [ -z "$sshKey" ] ; then
  826. continue
  827. fi
  828. # remove the old host key line
  829. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  830. # if key OK, add new host line
  831. if [ "$ok" -eq '0' ] ; then
  832. # note that key was found ok
  833. nKeysOK=$((nKeysOK+1))
  834. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  835. fi
  836. done
  837. # if at least one key was found...
  838. if [ "$nKeys" -gt 0 ] ; then
  839. # if ok keys were found, return 0
  840. if [ "$nKeysOK" -gt 0 ] ; then
  841. return 0
  842. # else return 2
  843. else
  844. return 2
  845. fi
  846. # if no keys were found, return 1
  847. else
  848. return 1
  849. fi
  850. }
  851. # update the authorized_keys files from a list of user IDs on command
  852. # line
  853. update_authorized_keys() {
  854. local returnCode=0
  855. local userID
  856. local nIDs
  857. local nIDsOK
  858. local nIDsBAD
  859. local fileCheck
  860. # the number of ids specified on command line
  861. nIDs="$#"
  862. nIDsOK=0
  863. nIDsBAD=0
  864. log debug "updating authorized_keys file:"
  865. log debug " $AUTHORIZED_KEYS"
  866. # check permissions on the authorized_keys file path
  867. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  868. # create a lockfile on authorized_keys
  869. lock create "$AUTHORIZED_KEYS"
  870. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  871. trap "lock remove $AUTHORIZED_KEYS" EXIT
  872. # note pre update file checksum
  873. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  874. # remove any monkeysphere lines from authorized_keys file
  875. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  876. for userID ; do
  877. # process the user ID, change return code if key not found for
  878. # user ID
  879. process_uid_authorized_keys "$userID" || returnCode="$?"
  880. # note the result
  881. case "$returnCode" in
  882. 0)
  883. nIDsOK=$((nIDsOK+1))
  884. ;;
  885. 2)
  886. nIDsBAD=$((nIDsBAD+1))
  887. ;;
  888. esac
  889. # touch the lockfile, for good measure.
  890. lock touch "$AUTHORIZED_KEYS"
  891. done
  892. # remove the lockfile and the trap
  893. lock remove "$AUTHORIZED_KEYS"
  894. # remove the trap
  895. trap - EXIT
  896. # note if the authorized_keys file was updated
  897. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  898. log debug "authorized_keys file updated."
  899. fi
  900. # if an acceptable id was found, return 0
  901. if [ "$nIDsOK" -gt 0 ] ; then
  902. return 0
  903. # else if no ok ids were found...
  904. else
  905. # if no bad ids were found then no ids were found at all, and
  906. # return 1
  907. if [ "$nIDsBAD" -eq 0 ] ; then
  908. return 1
  909. # else if at least one bad id was found, return 2
  910. else
  911. return 2
  912. fi
  913. fi
  914. }
  915. # process an authorized_user_ids file for authorized_keys
  916. process_authorized_user_ids() {
  917. local line
  918. local nline
  919. local userIDs
  920. authorizedUserIDs="$1"
  921. # exit if the authorized_user_ids file is empty
  922. if [ ! -e "$authorizedUserIDs" ] ; then
  923. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  924. fi
  925. log debug "processing authorized_user_ids file:"
  926. log debug " $authorizedUserIDs"
  927. # check permissions on the authorized_user_ids file path
  928. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  929. if ! meat "$authorizedUserIDs" >/dev/null ; then
  930. log debug " no user IDs to process."
  931. return
  932. fi
  933. nline=0
  934. # extract user IDs from authorized_user_ids file
  935. IFS=$'\n'
  936. for line in $(meat "$authorizedUserIDs") ; do
  937. userIDs["$nline"]="$line"
  938. nline=$((nline+1))
  939. done
  940. update_authorized_keys "${userIDs[@]}"
  941. }
  942. # takes a gpg key or keys on stdin, and outputs a list of
  943. # fingerprints, one per line:
  944. list_primary_fingerprints() {
  945. local fake=$(msmktempdir)
  946. GNUPGHOME="$fake" gpg --no-tty --quiet --import
  947. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  948. awk -F: '/^fpr:/{ print $10 }'
  949. rm -rf "$fake"
  950. }
  951. check_cruft_file() {
  952. local loc="$1"
  953. local version="$2"
  954. if [ -e "$loc" ] ; then
  955. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  956. fi
  957. }
  958. check_upgrade_dir() {
  959. local loc="$1"
  960. local version="$2"
  961. if [ -d "$loc" ] ; then
  962. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  963. fi
  964. }
  965. ## look for cruft from old versions of the monkeysphere, and notice if
  966. ## upgrades have not been run:
  967. report_cruft() {
  968. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  969. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  970. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  971. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  972. local found=
  973. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  974. if [ -d "$foo" ] ; then
  975. printf "! %s\n" "$foo" | log info
  976. found=true
  977. fi
  978. done
  979. if [ "$found" ] ; then
  980. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  981. fi
  982. }